extends ColorRect

signal selected_upgrade(upgrade)

var mouse_over = false
var item = null

@onready var player = get_tree().get_first_node_in_group("player")
@onready var name_label = $NameLabel
@onready var description_label = $DescriptionLabel
@onready var level_label = $LevelLabel
@onready var item_icon = $ColorRect/ItemIcon

# Called when the node enters the scene tree for the first time.
func _ready():
	connect("selected_upgrade", Callable(player, "upgrade_character"))
	if item == null:
		item = "food"
	name_label.text = UpgradeDb.UPGRADES[item]["displayname"]
	description_label.text = UpgradeDb.UPGRADES[item]["details"]
	level_label.text = UpgradeDb.UPGRADES[item]["level"]
	item_icon.texture = load(UpgradeDb.UPGRADES[item]["icon"])


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	pass


func _input(event):
	if event.is_action("click"):
		if mouse_over:
			selected_upgrade.emit(item)


func _on_mouse_entered():
	mouse_over = true


func _on_mouse_exited():
	mouse_over = false
